$! BID_ITEM.COM
$!  modified from David Jones' DCL_ENV_RM.COM
$!
$! This routine can be used to accept auction bids on a specific piece of
$! equipment.  This module looks up the highest bid on an item, then
$! accepts a bid.
$!
$ ALLBIDS  := [.AUCTION]ALLBIDS
$!
$! ALLBIDS are single records of the form:
$! NUMBER,12345,BIDVAL,123456789,BIDDER,xxxxxxxx,DATE,
$!    BIDVAL:            (in dollars, like 100.23)
$!    BIDDER:            (bidder's email address)
$! There is one ALLBIDS<number>.DAT file for each auction.
$!
$ write net_link "<DNETRECMODE>"	! Set implied carriage control.
$ mcr 'f$parse("SET_DCL_ENV.EXE;",f$environment("PROCEDURE")) "WWW_"
$!
$! Send back CGI response.  Note that newlines (<CR><LF>) must be
$! explicitly sent.
$!
$ set noon
$ set nover
$ put = "write net_link"
$ put "content-type: text/html"
$ put "status: 200 (meaningless)"
$ put "extra-header: (meaningless)"
$ if www_request_method .eqs. "HEAD" then exit
$!
$ create net_link:

$ define sys$output net_link:
$!
$! find out which item they want to bid on:
$!
$ allin = WWW_KEY_COUNT - 2
$!
$! extract all fields except the user information
$!
$ homestring= "HOME"
$ busistring= "BUSI"
$ homesum = 0
$ busisum = 0
$ icount = 0
$ top:
$   icount = icount + 1
$   variable = www_key_'icount'
$   icount = icount + 1
$   value = www_key_'icount'
$   'variable' = value
$   if(variable .eqs. "NUMBER")then innumber = value
$   if(icount .le. allin)then goto top
$!
$! find the highest bid
$  highest = 0
$!
$ openit = allbids + innumber + ".DAT"
$ open/share/error=byebye2 ifil: 'openit'
$ loopin1:
$   read/end=doneloopin1/err=doneloopin1 ifil: string
$   if(string .eqs. ",")then goto doneloopin1
$   thisis = f$element(1,",",string)
$   thisis = f$edit(thisis,"UPCASE,COLLAPSE")
$   if(thisis .eqs. innumber)
$     then
$        thisis = f$element(3,",",string)
$        if(thisis .gt. highest)
$        then
$            highest = thisis        
$            dated   = f$element(5,",",string)
$        endif
$     endif
$   goto loopin1
$ doneloopin1:
$ close ifil:
$
$ write sys$Output "<HTML>"
$ write sys$Output "<HEAD>"
$ write sys$Output "<title>biology division auction system: BID module</title>"
$ write sys$Output "</HEAD>"
$ write sys$Output "<BODY>"
$ write sys$Output "Accepting bids on item number <B>''innumber'</B>"
$ write sys$Output "<BR><BR>"
$ write sys$Output "Current highest bid is <B>$''highest'</B> submitted <B>''dated'</B>"
$ write sys$Output "<BR><BR>"
$ ulset = 0
$ NUMLIST = "-1"
$!
$ minbidval = highest + 1
$ if(ulset .eqs. 1)then write sys$Output "</UL>"
$ write sys$output "<form method=""POST"" action=""/htbin/sell_item"">"
$ write sys$Output "<input name=""NUMBER"" type=""HIDDEN"" value=''innumber' size=0>"
$ write sys$Output "Your bid in whole dollars: <input name=""BIDVAL"" type=""integer"" value=''minbidval' size=8 maxlength=8>"
$ write sys$output "<BR>"
$ write sys$output "Your full name: "
$ write sys$output "<input name=""NAME"" type=""string"" value="""" size=40 maxlength=80>"
$ write sys$output "<BR>"
$ write sys$output "Your email address: "
$ write sys$output "<input name=""BIDDER"" type=""string"" value="""" size=40 maxlength=80>"
$ write sys$output "<BR>"
$ write sys$Output "<input type=""submit"" value=""  Submit  "">"
$! 
$ goto byebye
$ byebye2:
$ write sys$Output "Fatal error in bid system - sorry"
$ byebye:
$ write sys$Output "</BODY>"
$ write sys$Output "</HTML>"
$ deass sys$output
$ exit
