$! DISPLAYITEMS.COM
$! 26-JUN-1997, David Mathog, Biology Division, Caltech
$!
$!  modified from David Jones' DCL_ENV_RM.COM
$!
$! This routine can be used to accept auction bids on a specific piece of
$! equipment.  This module reads FORSALE and ALLBIDS info, and presents the
$! list of available equipment, and the highest current bid on each.
$!
$ FORSALE  = "[.AUCTION]FORSALE*.DAT"
$!
$! FORSALE records are of the form:
$! NAME: :KEY: :SUBMITTER: :MINBID:
$!  NUMBER unique number, appended to FORSALE
$!  NAME   name associated with each item
$!  KEY    submitter's access key
$!  SUBMITTER sumbitter's email
$!  MINBID minimum bid for an item
$!  description         (indented by one space)
$!
$ ITEMCNT just holds a counter so that items are numbered sequentially
$!
$ write net_link "<DNETRECMODE>"	! Set implied carriage control.
$ mcr 'f$parse("SET_DCL_ENV.EXE;",f$environment("PROCEDURE")) "WWW_"
$!
$! Send back CGI response.  Note that newlines (<CR><LF>) must be
$! explicitly sent.
$!
$ set noon
$ set nover
$ put = "write net_link"
$ put "content-type: text/html"
$ put "status: 200 (meaningless)"
$ put "extra-header: (meaningless)"
$ if www_request_method .eqs. "HEAD" then exit
$!
$ create net_link:

$ define sys$output net_link:
$!
$ number_items = 0
$ write sys$Output "<HTML>"
$ write sys$Output "<HEAD>"
$ write sys$Output "<title>biology division auction system</title>"
$ write sys$Output "</HEAD>"
$ write sys$Output "<BODY>"
$ write sys$output "<B>Biology division auction system - items for sale</B>"
$ write sys$Output "<P>"
$ write sys$Output "<I>Select the title of an item to bid on it, or to see the current highest bid.</I><P>"
$ ulset = 0
$!
$! Put up the item info first:
$!
$ searchloop:
$ file = f$search(forsale)
$ if(file .nes. "")
$ then
$   short = f$parse(FILE,,,"NAME")
$   innumber = short - "FORSALE"
$   open/share=read itemfil: 'file'
$   read/end=doneloopin1/err=doneloopin1 itemfil: string
$   inname   = f$element(1,":",string)
$   inseller = f$element(7,":",string)
$   inemail  = f$element(5,":",string)
$   number_items = number_items + 1
$   write sys$Output "(<A href=""/htbin/bid_item?NUMBER=''innumber'"">#<B>''innumber'</B>)"
$   write sys$Output "<B>''inname'</B></A>"
$   write sys$Output "<UL>"
$   write sys$Output "seller <B>''inseller',</B> email: <B><A HREF=""mailto:''inemail'"">''inemail'</A></B>"
$   write sys$Output "</UL>"
$   ulset  = 1
$   loopin1:
$     read/end=doneloopin1/err=doneloopin1 itemfil: string
$     write sys$output string
$     goto loopin1
$   doneloopin1:
$   if(ulset .eq. 1)then write sys$Output "</UL>"
$   close itemfil:
$   goto searchloop
$ endif
$!
$ if(number_items .eq. 0)
$ then
$   write sys$Output "There are currently no items for sale."
$ endif
$ if(ulset .eqs. 1)then write sys$Output "</UL>"
$ write sys$Output "<A href=""/www/sell_item.html"">Return to main auction page</A>"
$ write sys$Output "</BODY>"
$ write sys$Output "</HTML>"
$ deass sys$output
$ exit
